% Implementation of Quaternionic Michelson Contrast Binary Pattern using
% the quaternionic Michelson contrast
% Reference: Lan R, Zhou Y. Quaternion-Michelson Descriptor for Color Image Classification [J], to be published in IEEE Transactions on Image Processing, 2016.
% Rushi Lan, rslan2012@gmail.com


clear, clc, close all
% im = imread('exam5.png');
im = imread('44a-scale_9_im_11_col.png');
figure, imshow(im);
r_local = 1;   % the size of local patch to extract contrast

% im = my_color_filtering(im);

im = double(im);

[m n colordim] = size(im);

% lbp_im_m = zeros(m, n);
lbp_im_I = zeros(m, n);
lbp_im_J = zeros(m, n);
lbp_im_K = zeros(m, n);

eim = padarray(im, [r_local r_local], 'symmetric');

% im = double(im)./255;
eim = double(eim)./255;
[mm nn cd] = size(eim);
% im = quaternion(im(:,:,1), im(:,:,2), im(:,:,3));
eim = quaternion(eim(:,:,1), eim(:,:,2), eim(:,:,3));

% abs_eim = abs(eim);

temp = eim.*(quaternion(1,0,0)/sqrt(1));
angle_eimI = angle(temp);

temp = eim.*(quaternion(0,1,0)/sqrt(1));
angle_eimJ = angle(temp);

temp = eim.*(quaternion(0,0,1)/sqrt(1));
angle_eimK = angle(temp);


for i = (r_local+1):(mm-r_local)
    for j = (r_local+1):(nn-r_local)
%         temp = abs_eim(i-r_local:i+r_local, j-r_local:j+r_local);
%         temp_q = eim(i-r_local:i+r_local, j-r_local:j+r_local);
%         temp_max = max(temp(:)); temp_min = min(temp(:));
%         [imax jmax] = find(temp==temp_max);  [imin jmin] = find(temp==temp_min);
%         value = (temp_q(imax(1),jmax(1))-temp_q(imin(1),jmin(1)))/(temp_q(imax(1),jmax(1))+temp_q(imin(1),jmin(1))+eps); 
%         lbp_im_m(i-r_local, j-r_local) = angle(value);

        temp = angle_eimI(i-r_local:i+r_local, j-r_local:j+r_local);
        temp_q = eim(i-r_local:i+r_local, j-r_local:j+r_local);
        temp_max = max(temp(:)); temp_min = min(temp(:));
        [imax jmax] = find(temp==temp_max);  [imin jmin] = find(temp==temp_min);
        value = (temp_q(imax(1),jmax(1))-temp_q(imin(1),jmin(1)))/(temp_q(imax(1),jmax(1))+temp_q(imin(1),jmin(1))+eps); 
        lbp_im_angleI(i-r_local, j-r_local) = angle(value);

        temp = angle_eimJ(i-r_local:i+r_local, j-r_local:j+r_local);
        temp_q = eim(i-r_local:i+r_local, j-r_local:j+r_local);
        temp_max = max(temp(:)); temp_min = min(temp(:));
        [imax jmax] = find(temp==temp_max);  [imin jmin] = find(temp==temp_min);
        value = (temp_q(imax(1),jmax(1))-temp_q(imin(1),jmin(1)))/(temp_q(imax(1),jmax(1))+temp_q(imin(1),jmin(1))+eps); 
        lbp_im_angleJ(i-r_local, j-r_local) = angle(value);  
        
        temp = angle_eimK(i-r_local:i+r_local, j-r_local:j+r_local);
        temp_q = eim(i-r_local:i+r_local, j-r_local:j+r_local);
        temp_max = max(temp(:)); temp_min = min(temp(:));
        [imax jmax] = find(temp==temp_max);  [imin jmin] = find(temp==temp_min);
        value = (temp_q(imax(1),jmax(1))-temp_q(imin(1),jmin(1)))/(temp_q(imax(1),jmax(1))+temp_q(imin(1),jmin(1))+eps); 
        lbp_im_angleK(i-r_local, j-r_local) = angle(value);
    end
end

mapping=getmapping(8,'u2');
% h1=lbp(lbp_im_m,1,8,mapping,'nh');
h2=lbp(lbp_im_angleI,1,8,mapping,'nh');
h3=lbp(lbp_im_angleJ,1,8,mapping,'nh');
h4=lbp(lbp_im_angleK,1,8,mapping,'nh');